## chromaprint 1.6.0

=== src/CMakeLists.txt ===
include_directories(${CMAKE_CURRENT_SOURCE_DIR})

set(chromaprint_SOURCES
  audio_processor.cpp
  chroma.cpp
  chroma_resampler.cpp
  chroma_filter.cpp
  spectrum.cpp
  fft.cpp
  fingerprinter.cpp
  image_builder.cpp
  simhash.h
  simhash.cpp
  silence_remover.cpp
  fingerprint_calculator.cpp
  fingerprint_compressor.cpp
  fingerprint_decompressor.cpp
  fingerprinter_configuration.cpp
  fingerprint_matcher.h
  fingerprint_matcher.cpp
  utils/base64.h
  utils/base64.cpp
  utils/gradient.h
  utils/gaussian_filter.h
  utils/scope_exit.h
  utils/rolling_integral_image.h
  audio/audio_slicer.h
)

set(chromaprint_PUBLIC_SOURCES chromaprint.cpp)
set(chromaprint_PUBLIC_HEADERS chromaprint.h)

if(USE_AVTX)
  set(chromaprint_SOURCES fft_lib_avtx.cpp ${chromaprint_SOURCES})
  set(chromaprint_LINK_LIBS
    ${FFMPEG_LIBAVUTIL_LIBRARIES}
  )
  include_directories(
    ${FFMPEG_LIBAVUTIL_INCLUDE_DIRS}
  )
endif(USE_AVTX)

if(USE_AVFFT)
  set(chromaprint_SOURCES fft_lib_avfft.cpp ${chromaprint_SOURCES})
  set(chromaprint_LINK_LIBS
    ${FFMPEG_LIBAVCODEC_LIBRARIES}
    ${FFMPEG_LIBAVUTIL_LIBRARIES}
  )
  include_directories(
    ${FFMPEG_LIBAVCODEC_INCLUDE_DIRS}
    ${FFMPEG_LIBAVUTIL_INCLUDE_DIRS}
  )
endif(USE_AVFFT)

if(USE_FFTW3)
  set(chromaprint_SOURCES fft_lib_fftw3.cpp ${chromaprint_SOURCES})
  set(chromaprint_LINK_LIBS ${FFTW3_LIBRARIES})
  include_directories(${FFTW3_INCLUDE_DIR})
endif(USE_FFTW3)

if(USE_FFTW3F)
  set(chromaprint_SOURCES fft_lib_fftw3.cpp ${chromaprint_SOURCES})
  set(chromaprint_LINK_LIBS ${FFTW3_FFTWF_LIBRARY})
  include_directories(${FFTW3_INCLUDE_DIR})
endif(USE_FFTW3F)

if(USE_VDSP)
  set(chromaprint_SOURCES fft_lib_vdsp.cpp ${chromaprint_SOURCES})
  set(chromaprint_LINK_LIBS ${ACCELERATE_LIBRARIES})
endif()

if(USE_KISSFFT)
  set(chromaprint_SOURCES fft_lib_kissfft.cpp ${chromaprint_SOURCES} ${KISSFFT_SOURCES})
  include_directories(${KISSFFT_INCLUDE_DIRS})
endif()

if (USE_INTERNAL_AVRESAMPLE)
  set(chromaprint_SOURCES avresample/resample2.c ${chromaprint_SOURCES})
endif()

add_library(chromaprint_objs OBJECT ${chromaprint_SOURCES})
if(BUILD_SHARED_LIBS)
  set_target_properties(chromaprint_objs PROPERTIES POSITION_INDEPENDENT_CODE TRUE)
endif()

add_library(chromaprint ${chromaprint_PUBLIC_SOURCES} ${chromaprint_PUBLIC_HEADERS} $<TARGET_OBJECTS:chromaprint_objs>)
set_target_properties(chromaprint PROPERTIES
  DEFINE_SYMBOL CHROMAPRINT_API_EXPORTS
  PUBLIC_HEADER ${chromaprint_PUBLIC_HEADERS}
    VERSION ${chromaprint_VERSION}
    SOVERSION ${chromaprint_SOVERSION}
)
if(BUILD_FRAMEWORK)
  set_target_properties(chromaprint PROPERTIES FRAMEWORK TRUE)
endif()
target_link_libraries(chromaprint ${chromaprint_LINK_LIBS})

install(TARGETS chromaprint
  EXPORT ChromaprintTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
  PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
    COMPONENT chromaprint
)

if(BUILD_TOOLS)
  add_subdirectory(cmd)
endif()

=== src/cmd/CMakeLists.txt ===
find_package(FFmpeg REQUIRED)

include_directories(
  ${FFMPEG_LIBAVFORMAT_INCLUDE_DIRS}
  ${FFMPEG_LIBAVCODEC_INCLUDE_DIRS}
  ${FFMPEG_LIBAVUTIL_INCLUDE_DIRS}
  ${AUDIO_PROCESSOR_INCLUDE_DIRS}
)

set(fpcalc_LIBS
  chromaprint
  ${FFMPEG_LIBAVFORMAT_LIBRARIES}
  ${FFMPEG_LIBAVCODEC_LIBRARIES}
  ${FFMPEG_LIBAVUTIL_LIBRARIES}
  ${AUDIO_PROCESSOR_LIBRARIES}
  ${CMAKE_THREAD_LIBS_INIT}
)

set(fpcalc_LINK_FLAGS)

if(APPLE)
  set(fpcalc_LIBS ${fpcalc_LIBS} -lz)
  set(fpcalc_LINK_FLAGS "${fpcalc_LINK_FLAGS} -sectcreate __TEXT __info_plist ${CMAKE_CURRENT_BINARY_DIR}/fpcalc.Info.plist")
  configure_file(${CMAKE_CURRENT_SOURCE_DIR}/fpcalc.Info.plist.in ${CMAKE_CURRENT_BINARY_DIR}/fpcalc.Info.plist)
endif()

if(WIN32)
  set(fpcalc_LIBS ${fpcalc_LIBS} bcrypt)
endif()

add_library(fpcalc_libs INTERFACE)
target_link_libraries(fpcalc_libs INTERFACE ${fpcalc_LIBS})

add_executable(fpcalc fpcalc.cpp)
target_link_libraries(fpcalc PRIVATE fpcalc_libs)
if(fpcalc_LINK_FLAGS)
  set_target_properties(fpcalc PROPERTIES LINK_FLAGS ${fpcalc_LINK_FLAGS})
endif()

install(
  TARGETS fpcalc
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  COMPONENT fpcalc)

=== src/3rdparty/googletest/CMakeLists.txt ===
# Note: CMake support is community-based. The maintainers do not use CMake
# internally.

cmake_minimum_required(VERSION 3.13)

project(googletest-distribution)
set(GOOGLETEST_VERSION 1.16.0)

if(NOT CYGWIN AND NOT MSYS AND NOT ${CMAKE_SYSTEM_NAME} STREQUAL QNX)
  set(CMAKE_CXX_EXTENSIONS OFF)
endif()

enable_testing()

include(CMakeDependentOption)
include(GNUInstallDirs)

# Note that googlemock target already builds googletest.
option(BUILD_GMOCK "Builds the googlemock subproject" ON)
option(INSTALL_GTEST "Enable installation of googletest. (Projects embedding googletest may want to turn this OFF.)" ON)
option(GTEST_HAS_ABSL "Use Abseil and RE2. Requires Abseil and RE2 to be separately added to the build." OFF)

if(GTEST_HAS_ABSL)
  if(NOT TARGET absl::base)
    find_package(absl REQUIRED)
  endif()
  if(NOT TARGET re2::re2)
    find_package(re2 REQUIRED)
  endif()
endif()

if(BUILD_GMOCK)
  add_subdirectory( googlemock )
else()
  add_subdirectory( googletest )
endif()

=== src/3rdparty/kissfft/CMakeLists.txt ===
# Directory for easier includes
# Anywhere you see include(...) you can check <root>/cmake for that file
set(CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)

#
# Extract version from Makefile
#

file(READ Makefile _MAKEFILE_CONTENTS)

string(REGEX MATCH "KFVER_MAJOR = ([0-9]+)\n" KFVER_MAJOR_MATCH "${_MAKEFILE_CONTENTS}")
if(NOT KFVER_MAJOR_MATCH)
    message(FATAL_ERROR "Cannot extract major (ABI) version from Makefile")
endif()
set(KFVER_MAJOR "${CMAKE_MATCH_1}")

string(REGEX MATCH "KFVER_MINOR = ([0-9]+)\n" KFVER_MINOR_MATCH "${_MAKEFILE_CONTENTS}")
if(NOT KFVER_MINOR_MATCH)
    message(FATAL_ERROR "Cannot extract minor version from Makefile")
endif()
set(KFVER_MINOR "${CMAKE_MATCH_1}")

string(REGEX MATCH "KFVER_PATCH = ([0-9]+)\n" KFVER_PATCH_MATCH "${_MAKEFILE_CONTENTS}")
if(NOT KFVER_PATCH_MATCH)
    message(FATAL_ERROR "Cannot extract patch version from Makefile")
endif()
set(KFVER_PATCH "${CMAKE_MATCH_1}")

set(MAKEFILE_EXTRACTED_VERSION "${KFVER_MAJOR}.${KFVER_MINOR}.${KFVER_PATCH}")

#
# Declare CMake project
#

cmake_minimum_required(VERSION 3.6)
project(kissfft VERSION "${MAKEFILE_EXTRACTED_VERSION}")

#
# CMake configuration options
#

# Principal datatype: double, float (default), int16_t, int32_t, simd

set(KISSFFT_DATATYPE "float" CACHE STRING "Principal datatype of kissfft: double, float (default), int16_t, int32_t, simd")

# Additional options

option(KISSFFT_OPENMP "Build kissfft with OpenMP support" OFF)
option(KISSFFT_PKGCONFIG "Build pkg-config files" ON)
option(KISSFFT_STATIC "Build kissfft as static (ON) or shared library (OFF)" OFF)
option(KISSFFT_TEST "Build kissfft tests" ON)
option(KISSFFT_TOOLS "Build kissfft command-line tools" ON)
option(KISSFFT_USE_ALLOCA "Use alloca instead of malloc" OFF)

#
# Validate datatype
#

if (NOT KISSFFT_DATATYPE MATCHES "^double$" AND
    NOT KISSFFT_DATATYPE MATCHES "^float$" AND
    NOT KISSFFT_DATATYPE MATCHES "^int16_t$" AND
    NOT KISSFFT_DATATYPE MATCHES "^int32_t$" AND
    NOT KISSFFT_DATATYPE MATCHES "^simd$")
    message(FATAL_ERROR "Incorrect value of KISSFFT_DATATYPE! It can be one of: double, float, int16_t, int32_t, simd")
endif()

#
# Print principal datatype
#

message(STATUS "Building KissFFT with datatype: ${KISSFFT_DATATYPE}")
set(KISSFFT_OUTPUT_NAME "kissfft-${KISSFFT_DATATYPE}")

#
# Validate KISSFFT_STATIC
#

if (BUILD_SHARED_LIBS AND KISSFFT_STATIC)
    message(FATAL_ERROR "Conflicting CMake configuration: -DBUILD_SHARED_LIBS=ON and -DKISSFFT_STATIC=ON")
endif()

#
# Enable BUILD_SHARED_LIBS for shared library build before
# kissfft library is declared
#

if (NOT KISSFFT_STATIC)
    set(BUILD_SHARED_LIBS ON)
    message(STATUS "Building shared library")
else()
    message(STATUS "Building static library")
endif()

#
# Detect C compiler and pass appropriate flags
#

if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang|AppleClang")
    add_compile_options(-ffast-math -fomit-frame-pointer
        -W -Wall -Wcast-align -Wcast-qual -Wshadow -Wwrite-strings
        "$<$<COMPILE_LANGUAGE:C>:-Wstrict-prototypes;-Wmissing-prototypes;-Wnested-externs;-Wbad-function-cast>")
endif()

#
# Add GNUInstallDirs for GNU infrastructure before target)include_directories
#

if(CMAKE_SYSTEM_NAME MATCHES "^(Linux|kFreeBSD|GNU)$" AND NOT CMAKE_CROSSCOMPILING)
    include(GNUInstallDirs)
endif()

#
# Declare PKGINCLUDEDIR for kissfft include path
#

set(PKGINCLUDEDIR "${CMAKE_INSTALL_INCLUDEDIR}/kissfft")
message(STATUS "PKGINCLUDEDIR is ${PKGINCLUDEDIR}")

#
# Declare kissfft library ( libkissfft.a / libkissfft-${KISSFFT_DATATYPE}.so.${MAKEFILE_EXTRACTED_VERSION} )
#

add_library(kissfft
  kiss_fft.c
  kfc.c
  kiss_fftnd.c
  kiss_fftndr.c
  kiss_fftr.c)

target_include_directories(kissfft PUBLIC
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}>
    $<INSTALL_INTERFACE:${PKGINCLUDEDIR}>)

#
# Set compile definitions based on datatype and additional support flags
#

set(KISSFFT_COMPILE_DEFINITIONS)

#
# double / float
#

if(KISSFFT_DATATYPE MATCHES "^float$" OR KISSFFT_DATATYPE MATCHES "^double$")
    list(APPEND KISSFFT_COMPILE_DEFINITIONS kiss_fft_scalar=${KISSFFT_DATATYPE})
else()

    #
    # int16_t
    #

    if(KISSFFT_DATATYPE MATCHES "^int16_t$")
        list(APPEND KISSFFT_COMPILE_DEFINITIONS FIXED_POINT=16)
    else()

        #
        # int32_t
        #

        if(KISSFFT_DATATYPE MATCHES "^int32_t$")
            list(APPEND KISSFFT_COMPILE_DEFINITIONS FIXED_POINT=32)
        else()

            #
            # simd
            #

            if(KISSFFT_DATATYPE MATCHES "^simd$")
                list(APPEND KISSFFT_COMPILE_DEFINITIONS USE_SIMD)
                if (NOT MSVC)
                    target_compile_options(kissfft PRIVATE -msse)
                else()
                    target_compile_options(kissfft PRIVATE "/arch:SSE")
                endif()
            endif()
        endif()
    endif()
endif()

#
# OpenMP support
#

if(KISSFFT_OPENMP)
    if(CMAKE_C_COMPILER_ID MATCHES "GNU|Clang|AppleClang")
        if (NOT MSVC)
            target_compile_options(kissfft PRIVATE -fopenmp)
            if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
                target_link_libraries(kissfft PRIVATE "-fopenmp")
            else()
                target_link_options(kissfft PRIVATE -fopenmp)
            endif()
        else()
            target_compile_options(kissfft PRIVATE "/openmp")
            if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
                target_link_libraries(kissfft PRIVATE "/openmp")
            else()
                target_link_options(kissfft PRIVATE "/openmp")
            endif()
        endif()
        set(KISSFFT_EXPORT_SUFFIX "-openmp")
        set(KISSFFT_OUTPUT_NAME "kissfft-${KISSFFT_DATATYPE}-openmp")
    else()
        message(FATAL_ERROR "Don't know how to enable OpenMP for this compiler")
    endif()
endif()

#
# Shared / static library
#

if(NOT KISSFFT_STATIC)
    list(APPEND KISSFFT_COMPILE_DEFINITIONS KISS_FFT_SHARED)
    set_target_properties(kissfft PROPERTIES
        C_VISIBILITY_PRESET hidden)
    set(KISSFFT_EXPORT_SUFFIX "${KISSFFT_EXPORT_SUFFIX}-shared")
else()
    set(KISSFFT_EXPORT_SUFFIX "${KISSFFT_EXPORT_SUFFIX}-static")
endif()

#
# Alloca support
#

if(KISSFFT_USE_ALLOCA)
    list(APPEND KISSFFT_COMPILE_DEFINITIONS KISS_FFT_USE_ALLOCA)
endif()

# Set library name, version, soversion and aliases

target_compile_definitions(kissfft PUBLIC ${KISSFFT_COMPILE_DEFINITIONS})
set_target_properties(kissfft PROPERTIES
    OUTPUT_NAME "${KISSFFT_OUTPUT_NAME}"
    DEFINE_SYMBOL KISS_FFT_BUILD
    EXPORT_NAME "${KISSFFT_OUTPUT_NAME}"
    VERSION ${PROJECT_VERSION}
    SOVERSION ${KFVER_MAJOR})
add_library(kissfft::kissfft ALIAS kissfft)
add_library(kissfft::kissfft-${KISSFFT_DATATYPE} ALIAS kissfft)

#
# Build with libm (-lm) on Linux and kFreeBSD
#

if(CMAKE_SYSTEM_NAME MATCHES "^(Linux|kFreeBSD|GNU)$" AND NOT CMAKE_CROSSCOMPILING)
    target_link_libraries(kissfft PRIVATE m)
endif()

#
# Define a helper function to define executable file
#

function(add_kissfft_executable NAME)
    add_executable(${NAME} ${ARGN})
    target_link_libraries(${NAME} PRIVATE kissfft::kissfft)

    #
    # Build with libm (-lm) on Linux and kFreeBSD
    #

    if(CMAKE_SYSTEM_NAME MATCHES "^(Linux|kFreeBSD|GNU)$" AND NOT CMAKE_CROSSCOMPILING)
        target_link_libraries(${NAME} PRIVATE m)
    endif()

    if (NOT KISSFFT_OPENMP)
        set_target_properties(${NAME} PROPERTIES
            OUTPUT_NAME "${NAME}-${KISSFFT_DATATYPE}")
    else()
        if (NOT MSVC)
            target_compile_options(${NAME} PRIVATE -fopenmp)
            if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
                target_link_libraries(${NAME} PRIVATE "-fopenmp")
            else()
                target_link_options(${NAME} PRIVATE -fopenmp)
            endif()
        else()
            target_compile_options(${NAME} PRIVATE "/openmp")
            if(${CMAKE_VERSION} VERSION_LESS "3.13.0")
                target_link_libraries(${NAME} PRIVATE "/openmp")
            else()
                target_link_options(${NAME} PRIVATE "/openmp")
            endif()
        endif()
        set_target_properties(${NAME} PROPERTIES
            OUTPUT_NAME "${NAME}-${KISSFFT_DATATYPE}-openmp")
    endif()
endfunction()

#
# Perform installation of kissfft library and development files
#

install(TARGETS kissfft EXPORT kissfft
    ARCHIVE DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    LIBRARY DESTINATION "${CMAKE_INSTALL_LIBDIR}"
    RUNTIME DESTINATION "${CMAKE_INSTALL_BINDIR}")

install(FILES kiss_fft.h
              kissfft.hh
              kiss_fftnd.h
              kiss_fftndr.h
              kiss_fftr.h
        DESTINATION "${PKGINCLUDEDIR}")

set(KISSFFT_INSTALL_CMAKE "${CMAKE_INSTALL_LIBDIR}/cmake/${PROJECT_NAME}"
    CACHE FILEPATH "Install destination of kissfft cmake modules")
mark_as_advanced(KISSFFT_INSTALL_CMAKE)

install(EXPORT kissfft DESTINATION "${KISSFFT_INSTALL_CMAKE}"
        NAMESPACE "kissfft::"
        FILE "${PROJECT_NAME}-${KISSFFT_DATATYPE}${KISSFFT_EXPORT_SUFFIX}-targets.cmake")
include(CMakePackageConfigHelpers)
configure_package_config_file(kissfft-config.cmake.in kissfft-config.cmake
    INSTALL_DESTINATION "${KISSFFT_INSTALL_CMAKE}")
write_basic_package_version_file(kissfft-config-version.cmake COMPATIBILITY AnyNewerVersion)
install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kissfft-config.cmake" "${CMAKE_CURRENT_BINARY_DIR}/kissfft-config-version.cmake"
        DESTINATION "${KISSFFT_INSTALL_CMAKE}")

set(PKG_KISSFFT_DEFS)
foreach(_def ${KISSFFT_COMPILE_DEFINITIONS})
    set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} -D${_def}")
endforeach()
if (KISSFFT_PKGCONFIG)
    include(JoinPaths)
    set(PKGCONFIG_KISSFFT_PKGINCLUDEDIR "\${includedir}/kissfft")
    set(PKGCONFIG_KISSFFT_PREFIX "${CMAKE_INSTALL_PREFIX}")
    set(PKGCONFIG_KISSFFT_VERSION "${kissfft_VERSION}")
    join_paths(PKGCONFIG_KISSFFT_LIBDIR "\${prefix}" "${CMAKE_INSTALL_LIBDIR}")
    join_paths(PKGCONFIG_KISSFFT_INCLUDEDIR "\${prefix}" "${CMAKE_INSTALL_INCLUDEDIR}")
    if(KISSFFT_DATATYPE MATCHES "^simd$")
       list(APPEND KISSFFT_COMPILE_DEFINITIONS USE_SIMD)
       if (NOT MSVC)
           set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} -msse")
       else()
           set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} /ARCH:SSE")
       endif()
    endif()
    if (NOT KISSFFT_OPENMP)
        configure_file(kissfft.pc.in "kissfft-${KISSFFT_DATATYPE}.pc" @ONLY)
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kissfft-${KISSFFT_DATATYPE}.pc"
                DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
    else()
        if (NOT MSVC)
            set(PKG_OPENMP "-fopenmp")
            set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} -fopenmp")
        else()
            set(PKG_KISSFFT_DEFS "${PKG_KISSFFT_DEFS} /openmp")
            set(PKG_OPENMP "/openmp")
        endif()
        configure_file(kissfft.pc.in "kissfft-${KISSFFT_DATATYPE}-openmp.pc" @ONLY)
        install(FILES "${CMAKE_CURRENT_BINARY_DIR}/kissfft-${KISSFFT_DATATYPE}-openmp.pc"
                DESTINATION "${CMAKE_INSTALL_LIBDIR}/pkgconfig")
    endif()
endif()

#
# Build and install tools if requested by user
#

if(KISSFFT_TOOLS)
    add_subdirectory(tools)
endif()

#
# Build and run tests if requested by user
#

if(KISSFFT_TEST)
    enable_testing()
    add_subdirectory(test)
endif()

=== src/3rdparty/kissfft/Makefile ===
#
# Semantic versioning
#
# KFVER_MAJOR denotes the ABI version.
#
# - It must be bumped only if API public members are removed or
#   changed in the incompatible
#
# KFVER_MINOR denotes the minor version within a compatible ABI.
#
# - It should be bumped if new API public members are added
#   (but not removed!) so programs linked against the same library
#   version continue operating properly
#
# KFVER_PATCH denotes bugfix count since the last minor update.
#
# - It should be bumped whenever a bug fix is pushed.
#

export KFVER_MAJOR = 131
export KFVER_MINOR = 1
export KFVER_PATCH = 0

#
# Data type (float / int16_t / int32_t / simd)
#

export KISSFFT_DATATYPE ?= float

#
# Default options
#

export KISSFFT_OPENMP ?= 0
export KISSFFT_STATIC ?= 0
export KISSFFT_TOOLS ?= 1
export KISSFFT_USE_ALLOCA ?= 0

#
# Installation directories
#

PREFIX ?= /usr/local
export ABS_PREFIX = $(abspath $(PREFIX))

BINDIR ?= $(ABS_PREFIX)/bin
export ABS_BINDIR = $(abspath $(BINDIR))

INCLUDEDIR ?= $(ABS_PREFIX)/include
export ABS_INCLUDEDIR = $(abspath $(INCLUDEDIR))
export ABS_PKGINCLUDEDIR = $(ABS_INCLUDEDIR)/kissfft

#
# Override LIBDIR with lib64 following CMake's
# GNUInstallDirs logic:
#

CANDIDATE_LIBDIR_NAME = lib

ifneq ($(MAKECMDGOALS),clean)
  ifeq ($(shell uname -s),Linux)
    _UNAME_ARCH = $(shell uname -i)

    ifeq (,$(_UNAME_ARCH))
	_UNAME_ARCH = $(shell uname -m)

      ifeq (,$(_UNAME_ARCH))
	$(warning WARNING: Can not detect system architecture!)
      endif
    endif

    ifeq ($(_UNAME_ARCH),x86_64)
	CANDIDATE_LIBDIR_NAME = lib64
    endif
  endif
endif

CANDIDATE_LIBDIR = $(PREFIX)/$(CANDIDATE_LIBDIR_NAME)
LIBDIR ?= $(CANDIDATE_LIBDIR)

export ABS_LIBDIR = $(abspath $(LIBDIR))

export INSTALL ?= install

#
# Library name and version
#

ifeq ($(KISSFFT_OPENMP), 1)
	KISSFFTLIB_SHORTNAME = kissfft-$(KISSFFT_DATATYPE)-openmp
	KISSFFT_PKGCONFIG = kissfft-$(KISSFFT_DATATYPE)-openmp.pc
	KISSFFTLIB_FLAGS = -fopenmp
	TYPEFLAGS = -fopenmp
	PKGCONFIG_OPENMP = -fopenmp
else
	KISSFFTLIB_SHORTNAME = kissfft-$(KISSFFT_DATATYPE)
	KISSFFT_PKGCONFIG = kissfft-$(KISSFFT_DATATYPE).pc
	TYPEFLAGS =
	PKGCONFIG_OPENMP =
endif

ifeq ($(KISSFFT_STATIC), 1)
	KISSFFTLIB_NAME = lib$(KISSFFTLIB_SHORTNAME).a
	KISSFFTLIB_FLAGS += -static
else ifeq ($(shell uname -s),Darwin)
	KISSFFTLIB_NAME = lib$(KISSFFTLIB_SHORTNAME).dylib
	KISSFFTLIB_FLAGS += -shared -Wl,-install_name,$(KISSFFTLIB_NAME)
else
	KISSFFTLIB_SODEVELNAME = lib$(KISSFFTLIB_SHORTNAME).so
	KISSFFTLIB_SONAME = $(KISSFFTLIB_SODEVELNAME).$(KFVER_MAJOR)
	KISSFFTLIB_NAME = $(KISSFFTLIB_SONAME).$(KFVER_MINOR).$(KFVER_PATCH)
	KISSFFTLIB_FLAGS += -shared -Wl,-soname,$(KISSFFTLIB_SONAME)
endif

export KISSFFTLIB_SHORTNAME

#
# Compile-time definitions by datatype
#
#
# Note: -DKISS_FFT_BUILD and -DKISS_FFT_SHARED control
# C symbol visibility.
#

ifeq "$(KISSFFT_DATATYPE)" "int32_t"
	TYPEFLAGS += -DFIXED_POINT=32
else ifeq "$(KISSFFT_DATATYPE)" "int16_t"
	TYPEFLAGS += -DFIXED_POINT=16
else ifeq "$(KISSFFT_DATATYPE)" "simd"
	TYPEFLAGS += -DUSE_SIMD=1 -msse
else ifeq "$(KISSFFT_DATATYPE)" "float"
	TYPEFLAGS += -Dkiss_fft_scalar=$(KISSFFT_DATATYPE)
else ifeq "$(KISSFFT_DATATYPE)" "double"
	TYPEFLAGS += -Dkiss_fft_scalar=$(KISSFFT_DATATYPE)
else
	$(error ERROR: KISSFFT_DATATYPE must be one of: float double int16_t int32_t simd)
endif

ifneq ($(KISSFFT_STATIC), 1)
	TYPEFLAGS += -DKISS_FFT_SHARED
endif

ifeq ($(KISSFFT_USE_ALLOCA), 1)
	TYPEFLAGS += -DKISS_FFT_USE_ALLOCA=1
endif

#
# Compile-time definitions
#

#
# Save pkgconfig variables before appending
# -DKISS_FFT_BUILD to TYPEFLAGS
#

ifneq ($(shell uname -s),Darwin)
	PKGCONFIG_KISSFFT_VERSION = $(KFVER_MAJOR).$(KFVER_MINOR).$(KFVER_PATCH)
	PKGCONFIG_KISSFFT_OUTPUT_NAME = $(KISSFFTLIB_SHORTNAME)
	PKGCONFIG_PKG_KISSFFT_DEFS = $(TYPEFLAGS)
	PKGCONFIG_KISSFFT_PREFIX = $(ABS_PREFIX)
  ifeq ($(ABS_INCLUDEDIR),$(ABS_PREFIX)/include)
	PKGCONFIG_KISSFFT_INCLUDEDIR = $${prefix}/include
  else
	PKGCONFIG_KISSFFT_INCLUDEDIR = $(ABS_INCLUDEDIR)

  endif
  ifeq ($(ABS_LIBDIR),$(ABS_PREFIX)/$(CANDIDATE_LIBDIR_NAME))
	PKGCONFIG_KISSFFT_LIBDIR = $${prefix}/$(CANDIDATE_LIBDIR_NAME)
  else
	PKGCONFIG_KISSFFT_LIBDIR = $(ABS_LIBDIR)
  endif
	PKGCONFIG_KISSFFT_PKGINCLUDEDIR = $${includedir}/kissfft
endif

export TYPEFLAGS

# Compile .c into .o
#

#
# -DKISS_FFT_BUILD is used for library artifacts, so
# consumer executable in 'test' and 'tools' do _NOT_
# need it. pkg-config output does not need it either.
#

%.c.o: %.c
	$(CC) -Wall -fPIC \
		-o $@ \
		$(CFLAGS) $(TYPEFLAGS) -DKISS_FFT_BUILD \
		-c $<

#
# Target: "make all"
#

all: kfc.c.o kiss_fft.c.o kiss_fftnd.c.o kiss_fftndr.c.o kiss_fftr.c.o
ifneq ($(KISSFFT_STATIC), 1)
	$(CC) $(KISSFFTLIB_FLAGS) -o $(KISSFFTLIB_NAME) $^
  ifneq ($(shell uname -s),Darwin)
	ln -sf $(KISSFFTLIB_NAME) $(KISSFFTLIB_SONAME)
	ln -sf $(KISSFFTLIB_NAME) $(KISSFFTLIB_SODEVELNAME)
  endif
else
	$(AR) crus $(KISSFFTLIB_NAME) $^
endif
ifneq ($(KISSFFT_TOOLS), 0)
	$(MAKE) -C tools CFLAGADD="$(CFLAGADD)" all
endif

#
# Target: "make install"
#

install: all
	$(INSTALL) -Dt $(ABS_PKGINCLUDEDIR) -m 644 \
		kiss_fft.h \
		kissfft.hh \
		kiss_fftnd.h \
		kiss_fftndr.h \
		kiss_fftr.h
	$(INSTALL) -Dt $(ABS_LIBDIR) -m 644 $(KISSFFTLIB_NAME)
ifneq ($(KISSFFT_STATIC), 1)
  ifneq ($(shell uname -s),Darwin)
	cd $(LIBDIR) && \
	ln -sf $(KISSFFTLIB_NAME) $(KISSFFTLIB_SONAME) && \
	ln -sf $(KISSFFTLIB_NAME) $(KISSFFTLIB_SODEVELNAME)
  endif
endif
ifneq ($(shell uname -s),Darwin)
	mkdir "$(ABS_LIBDIR)/pkgconfig"
	sed \
		-e 's+@PKGCONFIG_KISSFFT_VERSION@+$(PKGCONFIG_KISSFFT_VERSION)+' \
		-e 's+@KISSFFT_OUTPUT_NAME@+$(PKGCONFIG_KISSFFT_OUTPUT_NAME)+' \
		-e 's+@PKG_KISSFFT_DEFS@+$(PKGCONFIG_PKG_KISSFFT_DEFS)+' \
		-e 's+@PKG_OPENMP@+$(PKGCONFIG_OPENMP)+' \
		-e 's+@PKGCONFIG_KISSFFT_PREFIX@+$(PKGCONFIG_KISSFFT_PREFIX)+' \
		-e 's+@PKGCONFIG_KISSFFT_INCLUDEDIR@+$(PKGCONFIG_KISSFFT_INCLUDEDIR)+' \
		-e 's+@PKGCONFIG_KISSFFT_LIBDIR@+$(PKGCONFIG_KISSFFT_LIBDIR)+' \
		-e 's+@PKGCONFIG_KISSFFT_PKGINCLUDEDIR@+$(PKGCONFIG_KISSFFT_PKGINCLUDEDIR)+' \
		kissfft.pc.in 1>"$(ABS_LIBDIR)/pkgconfig/$(KISSFFT_PKGCONFIG)"
endif
ifneq ($(KISSFFT_TOOLS), 0)
	$(MAKE) -C tools install
endif

#
# Target: "make doc"
#

doc:
	$(warning Start by reading the README file.  If you want to build and test lots of stuff, do a 'make testall')
	$(warning but be aware that 'make testall' has dependencies that the basic kissfft software does not.)
	$(warning It is generally unneeded to run these tests yourself, unless you plan on changing the inner workings)
	$(warning of kissfft and would like to make use of its regression tests.)

#
# Target: "make testsingle"
#

testsingle:
	$(MAKE) clean
	$(MAKE) all
	$(MAKE) -C test CFLAGADD="$(CFLAGADD)" test testcpp

#
# Target: "make testall"
#

testall:
	# Shared libraries
	$(MAKE) KISSFFT_DATATYPE=double testsingle
	$(MAKE) KISSFFT_DATATYPE=float testsingle
	$(MAKE) KISSFFT_DATATYPE=int16_t testsingle
	# The simd and int32_t types may or may not work on your machine
	$(MAKE) KISSFFT_DATATYPE=int32_t testsingle
	$(MAKE) KISSFFT_DATATYPE=simd testsingle
	# Static libraries
	$(MAKE) KISSFFT_DATATYPE=double KISSFFT_STATIC=1 testsingle
	$(MAKE) KISSFFT_DATATYPE=float KISSFFT_STATIC=1 testsingle
	$(MAKE) KISSFFT_DATATYPE=int16_t KISSFFT_STATIC=1 testsingle
	# The simd and int32_t types may or may not work on your machine
	$(MAKE) KISSFFT_DATATYPE=int32_t KISSFFT_STATIC=1 testsingle
	$(MAKE) KISSFFT_DATATYPE=simd KISSFFT_STATIC=1 testsingle
	# OpenMP libraries
	$(MAKE) KISSFFT_DATATYPE=double KISSFFT_OPENMP=1 testsingle
	$(MAKE) KISSFFT_DATATYPE=float KISSFFT_OPENMP=1 testsingle
	$(MAKE) KISSFFT_DATATYPE=int16_t KISSFFT_OPENMP=1 testsingle
	# The simd and int32_t types may or may not work on your machine
	$(MAKE) KISSFFT_DATATYPE=int32_t KISSFFT_OPENMP=1 testsingle
	$(MAKE) KISSFFT_DATATYPE=simd KISSFFT_OPENMP=1 testsingle
	$(warning All tests passed!)

#
# Target: "make tarball"
#

tarball: clean
	git archive --prefix=kissfft/ -o kissfft$(KFVER).tar.gz v$(KFVER)
	git archive --prefix=kissfft/ -o kissfft$(KFVER).zip v$(KFVER)

#
# Target: "make clean"
#

clean:
	rm -f *.o *.a *.so *.so.*
	cd test && $(MAKE) clean
	cd tools && $(MAKE) clean
	rm -f kiss_fft*.tar.gz *~ *.pyc kiss_fft*.zip

#
# Target: "make asm"
#

asm: kiss_fft.s

# TODO: Sort out if we should add kfc / other C headers

kiss_fft.s: kiss_fft.c kiss_fft.h _kiss_fft_guts.h
	[ -e kiss_fft.s ] && mv kiss_fft.s kiss_fft.s~ || true
	$(CC) -S kiss_fft.c -O3 -mtune=native -ffast-math -fomit-frame-pointer -unroll-loops -dA -fverbose-asm
	$(CC) -o kiss_fft_short.s -S kiss_fft.c -O3 -mtune=native -ffast-math -fomit-frame-pointer -dA -fverbose-asm -DFIXED_POINT
	[ -e kiss_fft.s~ ] && diff kiss_fft.s~ kiss_fft.s || true

=== src/3rdparty/kissfft/test/CMakeLists.txt ===
function(add_kissfft_test_executable NAME)
    add_kissfft_executable(${NAME} ${ARGN})
    target_include_directories(${NAME} PRIVATE ..)

    add_test(NAME ${NAME} COMMAND ${NAME})
    set_tests_properties(${NAME} PROPERTIES TIMEOUT 3600)
endfunction()

set(KISSFFT_TEST_NUMFFTS 10000)

#
# Add tools-independent fastfilt_* (../tools/fft_*) executable without adding a test
#

add_kissfft_executable(fastfilt ../tools/fftutil.c)
target_include_directories(fastfilt PRIVATE ..)

#
# Add test executables and define tests
#

add_kissfft_test_executable(bm_kiss benchkiss.c pstats.c)
# add_test(NAME benchmar COMMAND ${NAME})
# set_tests_properties(${NAME} PROPERTIES TIMEOUT 3600)

include(FindPkgConfig)
if(KISSFFT_FLOAT)
    set(fftw3_pkg fftw3f)
else()
    set(fftw3_pkg fftw3)
endif()
pkg_check_modules(fftw3 REQUIRED IMPORTED_TARGET ${fftw3_pkg})
add_kissfft_test_executable(bm_fftw benchfftw.c pstats.c)
target_link_libraries(bm_fftw PRIVATE PkgConfig::fftw3)

add_kissfft_test_executable(st twotonetest.c)

add_kissfft_test_executable(tkfc twotonetest.c)
target_compile_definitions(tkfc PRIVATE KFC_TEST)

add_kissfft_test_executable(ffr twotonetest.c)
add_kissfft_test_executable(tr test_real.c)

add_kissfft_test_executable(testcpp testcpp.cc)

if(KISSFFT_DATATYPE MATCHES "^simd$")
    add_kissfft_test_executable(tsimd test_simd.c)
    target_compile_definitions(tsimd PRIVATE USE_SIMD)
    if (NOT MSVC)
        target_compile_options(kissfft PRIVATE -msse)
    else()
        target_compile_options(kissfft PRIVATE "/arch:SSE")
    endif()
endif()

find_package(PythonInterp REQUIRED)
add_test(NAME testkiss.py COMMAND "${PYTHON_EXECUTABLE}" "${CMAKE_CURRENT_SOURCE_DIR}/testkiss.py")
list(APPEND TESTKISS_PY_ENV "KISSFFT_DATATYPE=${KISSFFT_DATATYPE}")
list(APPEND TESTKISS_PY_ENV "KISSFFT_OPENMP=${KISSFFT_OPENMP}")
set_tests_properties(testkiss.py PROPERTIES
    TIMEOUT 3600
    ENVIRONMENT "${TESTKISS_PY_ENV}"
    WORKING_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}")

=== src/3rdparty/kissfft/test/Makefile ===
#
# Warnings
#

WARNINGS = -W -Wall -Wstrict-prototypes -Wmissing-prototypes  \
    -Wcast-align -Wcast-qual -Wnested-externs -Wshadow -Wbad-function-cast \
    -Wwrite-strings

#
# Compile-time definitions
#

CFLAGS  =  -O3 -I.. -I../tools $(WARNINGS)
CFLAGS += -ffast-math -fomit-frame-pointer
#CFLAGS += -funroll-loops
#CFLAGS += -march=prescott
#CFLAGS += -mtune=native
# TIP: try adding -openmp or -fopenmp  to enable OPENMP directives and use of multiple cores
#CFLAGS += -fopenmp
CFLAGS += $(CFLAGADD)

CXXFLAGS = -O3 -ffast-math -fomit-frame-pointer  -I.. -W -Wall -march=native -mtune=native

#
# Count of FFT runs tested
#

ifeq "$(NFFT)" ""
 NFFT = 1800
endif
ifeq "$(NUMFFTS)" ""
 NUMFFTS = 10000
endif

#
# Test binary executable names
#

SELFTESTSRC = twotonetest.c

ifneq ($(KISSFFT_OPENMP),1)
BENCHKISS = bm-kiss-$(KISSFFT_DATATYPE)
BENCHFFTW = bm-fftw-$(KISSFFT_DATATYPE)
SELFTEST = st-$(KISSFFT_DATATYPE)
TESTREAL = tr-$(KISSFFT_DATATYPE)
TESTKFC = tkfc-$(KISSFFT_DATATYPE)
TESTFASTFILT = fastfilt-$(KISSFFT_DATATYPE)
TESTCPP = testcpp-$(KISSFFT_DATATYPE)
TESTSIMD = testsimd
else
BENCHKISS = bm-kiss-$(KISSFFT_DATATYPE)-openmp
BENCHFFTW = bm-fftw-$(KISSFFT_DATATYPE)-openmp
SELFTEST = st-$(KISSFFT_DATATYPE)-openmp
TESTREAL = tr-$(KISSFFT_DATATYPE)-openmp
TESTKFC = tkfc-$(KISSFFT_DATATYPE)-openmp
TESTFASTFILT = fastfilt-$(KISSFFT_DATATYPE)-openmp
TESTCPP = testcpp-$(KISSFFT_DATATYPE)-openmp
TESTSIMD = testsimd-openmp
CFLAGS += -fopenmp
CXXFLAGS += -fopenmp
endif

ifeq "$(KISSFFT_DATATYPE)" "float"
 # fftw needs to be built with --enable-float to build this lib
 FFTWLIB = -lfftw3f
else
 FFTWLIB = -lfftw3
endif

FFTWLIBDIR ?= $(ABS_LIBDIR)
ABS_FFTWLIBDIR = $(abspath $(FFTWLIBDIR))

#
# Check missing external libraries
#

ifneq ($(MAKECMDGOALS),clean)
LIBFFTW_MISSING = $(shell echo "int main(){return 0;}" > _test_library_dummy.c; \
	$(CC) -o _test_library_dummy _test_library_dummy.c $(FFTWLIB) -L$(ABS_FFTWLIBDIR); \
	echo $$?; \
	rm -f _test_library_dummy.c _test_library_dummy)
endif

#
# Find Python interpreter
#

ifneq ($(MAKECMDGOALS),clean)
  PYTHON_INTERPRETER = $(shell python --version)
  ifeq ($(PYTHON_INTERPRETER), )
	PYTHON_INTERPRETER = $(shell python2 --version)
    ifeq ($(PYTHON_INTERPRETER), )
	PYTHON_INTERPRETER = $(shell python3 --version)
      ifeq ($(PYTHON_INTERPRETER), )
	$(error ERROR: Can not find Python interpreter!)
      else
	PYTHON_INTERPRETER = "python3"
      endif
    else
	PYTHON_INTERPRETER = "python2"
    endif
  else
	PYTHON_INTERPRETER = "python"
  endif
endif

#
# Target: "make all"
#

all: $(BENCHKISS) $(SELFTEST) $(BENCHFFTW) $(TESTREAL) $(TESTKFC) $(TESTFASTFILT)

#
# Individual test make rules
#

$(SELFTEST): $(SELFTESTSRC)
	$(CC) -o $@ $(CFLAGS) $(TYPEFLAGS) $< -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

$(TESTKFC): ../kfc.c
	$(CC) -o $@ $(CFLAGS)  -DKFC_TEST $(TYPEFLAGS) $^ -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

$(TESTREAL): test_real.c
	$(CC) -o $@ $(CFLAGS) $(TYPEFLAGS) $< -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

$(BENCHKISS): benchkiss.c pstats.c
	$(CC) -o $@ $(CFLAGS) $(TYPEFLAGS)  $^ -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

$(TESTFASTFILT): ../tools/fftutil.c
	$(CC) -o $@ $(CFLAGS)  -DKFC_TEST $(TYPEFLAGS) $^ -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

$(BENCHFFTW): benchfftw.c pstats.c
	$(warning ======attempting to build FFTW benchmark)
ifeq ($(LIBFFTW_MISSING), 0)
	$(CC) -o $@ $(CFLAGS) -DDATATYPE$(KISSFFT_DATATYPE) $^ $(FFTWLIB) -L$(ABS_FFTWLIBDIR) -L.. -l$(KISSFFTLIB_SHORTNAME) -lm
else
	$(warning WARNING: No FFTW development files found! FFTW not available for comparison!)
endif

#
# Test SSE
#

$(TESTSIMD): test_simd.c
ifeq "$(KISSFFT_DATATYPE)" "simd"
	$(CC) -o $@ -g $(CFLAGS) -DUSE_SIMD=1 -msse $< -L.. -l$(KISSFFTLIB_SHORTNAME) -lm
else
	$(error ERROR: This test makes sense only with KISSFFT_DATATYPE=simd)
endif

testsse: $(TESTSIMD)
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):.." ./$(TESTSIMD)

#
# Test C++
#

$(TESTCPP): testcpp.cc ../kissfft.hh
	$(CXX) -o $@ $(CXXFLAGS) testcpp.cc -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

testcpp: $(TESTCPP)
	LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):.." ./$(TESTCPP)

#
# Target: "make test"
#

test: all
ifeq "$(KISSFFT_DATATYPE)" "simd"
	$(MAKE) testsse
endif
	@LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):.." ./$(TESTKFC)
	$(warning ======1d & 2-d complex fft self test (type= $(KISSFFT_DATATYPE) ))
	@LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):.." ./$(SELFTEST)
	$(warning ======real FFT (type= $(KISSFFT_DATATYPE) ))
	@LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):.." ./$(TESTREAL)
	$(warning ======timing test (type=$(KISSFFT_DATATYPE)))
	@LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):.." ./$(BENCHKISS) -x $(NUMFFTS) -n $(NFFT)
	@[ -x ./$(BENCHFFTW) ] && LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):.." ./$(BENCHFFTW) -x $(NUMFFTS) -n $(NFFT) || true
	$(warning ======higher dimensions (type=$(KISSFFT_DATATYPE)))
	@LD_LIBRARY_PATH="$(LD_LIBRARY_PATH):.." $(PYTHON_INTERPRETER) ./testkiss.py

#
# Target: "make clean"
#

clean:
	rm -f *~ bm-* st-* tr-* kf-* tkfc-* ff-* fastfilt-* *.pyc *.pyo *.dat testcpp-* testsimd testsimd-* _test_library_dummy _test_library_dummy.c

=== src/3rdparty/kissfft/tools/Makefile ===
#
# Warnings
#

WARNINGS = -W -Wall -Wstrict-prototypes -Wmissing-prototypes \
    -Wcast-align -Wcast-qual -Wnested-externs -Wshadow -Wbad-function-cast \
    -Wwrite-strings

#
# Compile-time definitions
#

CFLAGS = -Wall -O3 $(WARNINGS)
#CFLAGS = -Wall -O3 -pedantic -march=pentiumpro -ffast-math -fomit-frame-pointer $(WARNINGS)
# If the above flags do not work, try the following
# tip: try -openmp or -fopenmp to use multiple cores

CFLAGS += $(CFLAGADD)

#
# Check missing external libraries
#

ifneq ($(MAKECMDGOALS),clean)
LIBPNG_MISSING = $(shell echo "int main(){return 0;}" > _test_library_dummy.c; \
	$(CC) -o _test_library_dummy _test_library_dummy.c -lpng; \
	echo $$?; \
	rm -f _test_library_dummy.c _test_library_dummy)
endif

#
# Tool names
#

ifneq ($(KISSFFT_OPENMP),1)
FFTUTIL = fft-$(KISSFFT_DATATYPE)
FASTFILT = fastconv-$(KISSFFT_DATATYPE)
FASTFILTREAL = fastconvr-$(KISSFFT_DATATYPE)
PSDPNG = psdpng-$(KISSFFT_DATATYPE)
DUMPHDR = dumphdr-$(KISSFFT_DATATYPE)
else
FFTUTIL = fft-$(KISSFFT_DATATYPE)-openmp
FASTFILT = fastconv-$(KISSFFT_DATATYPE)-openmp
FASTFILTREAL = fastconvr-$(KISSFFT_DATATYPE)-openmp
PSDPNG = psdpng-$(KISSFFT_DATATYPE)-openmp
DUMPHDR = dumphdr-$(KISSFFT_DATATYPE)-openmp
endif

#
# Target: "make all"
#

all: $(FFTUTIL) $(FASTFILT) $(FASTFILTREAL) $(PSDPNG)
#	$(DUMPHDR)

#
# Individual tool make rules
#

$(FASTFILTREAL): kiss_fastfir.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) -DREAL_FASTFIR $< -DFAST_FILT_UTIL -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

$(FASTFILT): kiss_fastfir.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) $<  -DFAST_FILT_UTIL -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

$(FFTUTIL): fftutil.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) $< -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

$(PSDPNG): psdpng.c
ifeq "$(KISSFFT_DATATYPE)" "simd"
	$(warning WARNING: psdpng can not utilize SIMD!)
else ifeq ($(LIBPNG_MISSING), 0)
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) $< -L.. -l$(KISSFFTLIB_SHORTNAME) -lpng -lm
else
	$(error ERROR: no libpng development files found!)
endif

$(DUMPHDR): dumphdr.c
	$(CC) -o $@ $(CFLAGS) -I.. $(TYPEFLAGS) $< -L.. -l$(KISSFFTLIB_SHORTNAME) -lm

#
# Target: "make install"
#

install: all
	$(INSTALL) -Dt $(ABS_BINDIR) -m 755 \
		$(FFTUTIL) \
		$(FASTFILT) \
		$(FASTFILTREAL)

ifneq "$(KISSFFT_DATATYPE)" "simd"
	$(INSTALL) -Dt $(ABS_BINDIR) -m 755 \
		$(PSDPNG)
endif

#
# Target: "make clean"
#

clean:
	rm -f *~ fft fft-* fastconv fastconv-* fastconvr fastconvr-* psdpng psdpng-* _test_library_dummy _test_library_dummy.c

=== debian/changelog ===
chromaprint (1.6.0-2) unstable; urgency=medium

  [ Helmut Grohne ]
  * Honour DEB_BUILD_OPTIONS=nocheck (Closes: #1112686)

 -- Sebastian Ramacher <sramacher@debian.org>  Fri, 26 Sep 2025 11:19:57 +0200

chromaprint (1.6.0-1) unstable; urgency=medium

  * New upstream version 1.6.0
  * debian/control: Bump Standards-Version
  * debian/patches: Drop patches included upstream
  * debian/libchromaprint-dev.install: Install cmake files
  * debian/rules: Update for changes in upstream's build system
  * debian/copyright:
    - Bump copyright years
    - Remove FSF address
  * debian/libchromaprint1.symbols: Add new symbols

 -- Sebastian Ramacher <sramacher@debian.org>  Sat, 30 Aug 2025 18:10:44 +0200

=== debian/control ===
Source: chromaprint
Priority: optional
Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Sebastian Ramacher <sramacher@debian.org>,
 Reinhard Tartler <siretart@tauware.de>
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 libavcodec-dev,
 libavformat-dev,
 libgtest-dev <!nocheck>,
 libswresample-dev,
 python3-docutils
Standards-Version: 4.7.2
Section: libs
Homepage: https://acoustid.org/chromaprint
Vcs-Git: https://salsa.debian.org/multimedia-team/chromaprint.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/chromaprint
Rules-Requires-Root: no

Package: libchromaprint-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libchromaprint1 (= ${binary:Version}),
 ${misc:Depends}
Description: audio fingerprinting library - development files
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks
 .
 This package includes development files needed to compile programs
 using libchromaprint.

Package: libchromaprint1
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: audio fingerprint library
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks

Package: libchromaprint-tools
Section: sound
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: audio fingerprinting library - tools
 Chromaprint is a library for calculating audio fingerprints
 which are used by the Acoustid service. Its main purpose is to provide an
 accurate identifier for record tracks
 .
 This package provides the fpcalc utility.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# export DH_VERBOSE=1

CONFIGURE_FLAGS  = -DBUILD_TOOLS=ON
CONFIGURE_FLAGS += -DBUILD_SHARED_LIBS=ON
CONFIGURE_FLAGS += -DFFT_LIB=kissfft

ifeq (,$(findstring nocheck,$(DEB_BUILD_OPTIONS)))
CONFIGURE_FLAGS += -DBUILD_TESTS=ON
CONFIGURE_FLAGS += -DGTEST_ROOT=/usr/src/googletest/googletest/
else
CONFIGURE_FLAGS += -DBUILD_TESTS=OFF
endif

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- $(CONFIGURE_FLAGS)

execute_before_dh_installman:
	rst2man debian/fpcalc.rst > debian/fpcalc.1

override_dh_installchangelogs:
	dh_installchangelogs NEWS.txt

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%chromaprint-$1.tar.gz%" \
    https://github.com/acoustid/chromaprint/tags \
    (?:.*?/)?v?(\d[\d.]*)\.tar\.gz
